/*
 Illinois Open Source License

 University of Illinois/NCSA
 Open Source License

 Copyright © 2009,    University of Illinois.  All rights reserved.

 Developed by:
 Innovative Systems Lab
 National Center for Supercomputing Applications
 http://www.ncsa.uiuc.edu/AboutUs/Directorates/ISL.html

 Permission is hereby granted, free of charge, to any person obtaining a copy of this 
 software and associated documentation files (the "Software"), to deal with the Software 
 without restriction, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit 
 persons to whom the Software is furnished to do so, subject to the following conditions:
 
 * Redistributions of source code must retain the above copyright notice, this list of 
   conditions and the following disclaimers.
 
 * Redistributions in binary form must reproduce the above copyright notice, this list of 
   conditions and the following disclaimers in the documentation and/or other materials 
   provided with the distribution.
 
 * Neither the names of Innovative Systems Lab and National Center for Supercomputing 
   Applications, nor the names of its contributors may be used to endorse or promote 
   products derived from this Software without specific prior written permission.
 
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
   INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE 
   LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT 
   OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
   DEALINGS WITH THE SOFTWARE.
 */

#ifndef __COMPUTE_TASK_H__
#define __COMPUTE_TASK_H__

#include <task.h>


#define ROUNDUP_4(x) ((x-1)/4*4+4)
#define ROUNDUP_8(x) ((x-1)/8*8+8)
#define ROUNDUP_16(x) ((x-1)/16*16+16)
#define ROUNDUP_32(x) ((x-1)/32*32+32)
#define ROUNDUP_64(x) ((x-1)/64*64+64)
#define ROUNDUP_128(x) ((x-1)/128*128+128)


#define ROUNDDOWN_4(x) ((x)/4*4)
#define ROUNDDOWN_8(x) ((x)/8*8)
#define ROUNDDOWN_16(x) ((x)/16*16)
#define ROUNDDOWN_32(x) ((x)/32*32)
#define ROUNDDOWN_64(x) ((x)/64*64)
#define ROUNDDOWN_128(x) ((x)/128*128)


#define FLAG_DD 1
#define FLAG_DR 2
#define FLAG_RR 3

typedef struct compute_task_s{
    task_t common;
    char* data1;
    int n1;
    char* data2;
    char* data2_v;
    int n2;
    int doSelf;
    long long** data_bins;
    int njk;
    int flag;
}compute_task_t;

typedef struct load_task_s{
    task_t common;
    double* binb;
    int nbins;
}load_task_t;

#define COMPUTE_TASK  1
#define LOAD_TASK 2




#endif

